package fileio;
import java.awt.event.ActionEvent;
import java.io.File;
import javax.swing.Icon;
import javax.swing.JFileChooser;
import javax.swing.filechooser.FileFilter;
import laf.CommandMap;

//--------------------------------------------------------------------//
/**
 * t@Cǂݍ݃ANV
 */
public abstract class FileOpenAction extends FileAccessAction{

/**
 * ANVIuWFNg\z
 */
  protected FileOpenAction(){
    super();
    putValue(NAME,actionName());
  }

/**
 * ACRw肵ăANVIuWFNg\z
 * @param icon ACR
 */
  protected FileOpenAction(Icon icon){
    super(icon);
    putValue(SHORT_DESCRIPTION,actionName());
  }

//--------------------------------------------------------------------//
/**
 * t@Cǂݍ
 * @param file ǂݍރt@C
 * @throws Exception 炩̗RŃt@Cǂ߂ȂƂ
 */
  protected abstract void open(File file) throws Exception;

//--------------------------------------------------------------------//
/**
 * t@Cǂݍ
 * @param e ANVƂCxg
 */
  public void actionPerformed(ActionEvent e){
    JFileChooser fileChooser=getFileChooser();
    int ans=fileChooser.showOpenDialog(getDialogOwner());
    if(ans!=fileChooser.APPROVE_OPTION) return;

    currentDirectory=fileChooser.getCurrentDirectory();
    FileFilter filter=fileChooser.getFileFilter();
    File file=modifiedFile(fileChooser.getSelectedFile(),filter);
    try{
      open(file);
    }
    catch(Exception ex){
      showErrorMessage("file open error.",ex);
    }
  }

//--------------------------------------------------------------------//
/**
 * ANV̂Ԃ
 * @return ANV
 */
  public static String actionName(){
    return CommandMap.get(CommandMap.LOAD);
  }
}
