package gui;
import java.awt.Dimension;
import java.awt.Graphics;
import java.awt.Graphics2D;
import java.awt.image.BufferedImage;
import java.awt.image.VolatileImage;
import javax.swing.JPanel;

//--------------------------------------------------------------------//
/**
 * W\pl
 */
public class BasicViewPanel extends JPanel{

/** ʃTCY */
  protected Dimension panelSize;

/** _uobt@OpC[W */
  protected VolatileImage bgImage;

/** _uobt@OpC[W̃OtBbNXReLXg */
  protected Graphics2D bg;

/**
 * W\pl\z
 */
  public BasicViewPanel(){
    super();
  }

//--------------------------------------------------------------------//
/**
 * ʃC[WԂ
 * @return ʃC[W
 */
  public BufferedImage getImage(){
    setPaint();
    BufferedImage image=new BufferedImage
      (panelSize.width,panelSize.height,BufferedImage.TYPE_INT_ARGB);
    paintModel(image.createGraphics());
    return image;
  }

//--------------------------------------------------------------------//
/**
 * ĕ`悷
 */
  public void update(){
    if(bg==null) setPaint();
    paintModel(bg);
    getGraphics().drawImage(bgImage,0,0,this);
  }

//--------------------------------------------------------------------//
/**
 * `悷
 * @param g `悷OtBbNXReLXg
 */
  protected void paintComponent(Graphics g){
    setPaint();
    paintModel(bg);
    g.drawImage(bgImage,0,0,this);
  }

//--------------------------------------------------------------------//
/**
 * ʂ̐ݒ
 */
  protected void setPaint(){
    panelSize=getSize();
    bgImage=createVolatileImage(panelSize.width,panelSize.height);
    bg=bgImage.createGraphics();
  }

//--------------------------------------------------------------------//
/**
 * `悷
 * @param g `悷OtBbNXReLXg
 */
  protected void paintModel(Graphics2D g){
  }

//--------------------------------------------------------------------//
/**
 * G[bZ[W\
 * @param g `悷OtBbNXReLXg
 * @param message G[bZ[W
 */
  protected void drawErrorMessage(Graphics2D g,String message){
    if(message!=null){
      g.drawString("Error:",3,20);
      g.drawString(message,10,40);
    }
    else{
      g.drawString("map paint error",3,20);
    }
  }
}
