package gui;
import java.awt.Component;
import java.awt.Dimension;
import java.awt.event.ActionEvent;
import java.io.IOException;
import javax.swing.AbstractAction;
import javax.swing.Icon;
import javax.swing.JOptionPane;
import javax.swing.JScrollPane;
import laf.CommandMap;
import resourcemanager.HelpManager;

//--------------------------------------------------------------------//
/**
 * wv\ANV
 */
public class HelpAction extends AbstractAction{

/** ftHg`ʃTCY */
  public static final Dimension DEFAULT_SIZE=new Dimension(360,360);

/** _CAO{^ */
  protected static final String BUTTON[]={"close"};

/** _CAȌL */
  protected Component base;

/** ŏɕ\y[W̃AhX */
  protected String initPage;

/**
 * ANVIuWFNg\z
 * @param base _CAȌL
 */
  public HelpAction(Component base){
    this(base,"");
  }

/**
 * ANVIuWFNg\z
 * @param base _CAȌL
 * @param initPage ŏɕ\y[W̃AhX
 */
  public HelpAction(Component base,String initPage){
    putValue(NAME,actionName());
    this.base=base;
    this.initPage=initPage;
  }

/**
 * ACRw肵ăANVIuWFNg\z
 * @param base _CAȌL
 * @param icon ACR
 */
  public HelpAction(Component base,Icon icon){
    this(base,"",icon);
  }

/**
 * ACRw肵ăANVIuWFNg\z
 * @param base _CAȌL
 * @param initPage ŏɕ\y[W̃AhX
 * @param icon ACR
 */
  public HelpAction(Component base,String initPage,Icon icon){
    putValue(SMALL_ICON,icon);
    putValue(SHORT_DESCRIPTION,actionName());
    this.base=base;
    this.initPage=initPage;
  }

//--------------------------------------------------------------------//
/**
 * wv\
 * @param e ANVƂCxg
 */
  public void actionPerformed(ActionEvent e){
    JOptionPane.showMessageDialog
      (base,getComponent(),actionName(),JOptionPane.PLAIN_MESSAGE);
  }

//--------------------------------------------------------------------//
/**
 * \R|[lgԂ
 * @return \R|[lg
 */
  public Component getComponent(){
    HTMLViewPane pane=new HTMLViewPane();
    pane.setSize(DEFAULT_SIZE);
    pane.setPreferredSize(DEFAULT_SIZE);
    try{
      if(initPage==null || initPage.equals("")){
      	pane.setPage(HelpManager.get());
      }
      else{
      	pane.setPage(HelpManager.get(initPage));
      }
    }
    catch(IOException ex){
      ex.printStackTrace();
    }
    return new JScrollPane(pane);
  }

//--------------------------------------------------------------------//
/**
 * ANV̂Ԃ
 * @return ANV
 */
  public static String actionName(){
    return CommandMap.get(CommandMap.HELP);
  }
}
