package gui;
import javax.swing.JSpinner;
import javax.swing.SpinnerNumberModel;
import javax.swing.border.TitledBorder;

//--------------------------------------------------------------------//
/**
 * ̓Xsi[
 */
public class IntNumberSpinner extends JSpinner{

/**
 * ̓Xsi[\z
 * @param title Xsi[̃^Cg
 */
  public IntNumberSpinner(String title){
    this(title,1,1,100,1);
  }

/**
 * ̓Xsi[\z
 * @param title Xsi[̃^Cg
 * @param value l
 * @param min ŏl
 * @param max ől
 */
  public IntNumberSpinner(String title,int value,int min,int max){
    this(title,value,min,max,1);
  }

/**
 * ̓Xsi[\z
 * @param title Xsi[̃^Cg
 * @param value l
 * @param min ŏl
 * @param max ől
 * @param step ݕ
 */
  public IntNumberSpinner(String title,int value,int min,int max,
      	      	      	  int step){
    super(new SpinnerNumberModel(value,min,max,step));
    if(title!=null) setBorder(new TitledBorder(title));
  }

//--------------------------------------------------------------------//
/**
 * ݒlԂ
 * @return ݒl
 */
  public int get(){
    Object value=getValue();
    if(value instanceof Number){
      return ((Number)value).intValue();
    }
    else{
      return -1;
    }
  }

//--------------------------------------------------------------------//
/**
 * lݒ肷
 * @param value ݒ肷l
 */
  public void set(int value){
    setValue(new Integer(value));
  }

//--------------------------------------------------------------------//
/**
 * ŏlԂ
 * @return ŏl
 */
  public int getMin(){
    Number min=(Number)((SpinnerNumberModel)getModel()).getMinimum();
    return min.intValue();
  }

//--------------------------------------------------------------------//
/**
 * ŏlݒ肷
 * @param min ݒ肷ŏl
 */
  public void setMin(int min){
   ((SpinnerNumberModel)getModel()).setMinimum(new Integer(min));
  }

//--------------------------------------------------------------------//
/**
 * őlԂ
 * @return ől
 */
  public int getMax(){
    Number max=(Number)((SpinnerNumberModel)getModel()).getMaximum();
    return max.intValue();
  }

//--------------------------------------------------------------------//
/**
 * őlݒ肷
 * @param max ݒ肷ől
 */
  public void setMax(int max){
   ((SpinnerNumberModel)getModel()).setMaximum(new Integer(max));
  }

//--------------------------------------------------------------------//
/**
 * ݕԂ
 * @return ݕ
 */
  public int getStep(){
    Number step=(Number)((SpinnerNumberModel)getModel()).getStepSize();
    return step.intValue();
  }

//--------------------------------------------------------------------//
/**
 * ݕݒ肷
 * @param step ݒ肷鍏ݕ
 */
  public void setStep(int step){
   ((SpinnerNumberModel)getModel()).setStepSize(new Integer(step));
  }
}
