package iso.component;
import java.awt.Point;
import java.awt.event.KeyEvent;
import java.awt.event.KeyListener;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;
import java.awt.event.MouseMotionListener;

//--------------------------------------------------------------------//
/**
 * ANVǗNX
 */
public class ChannelFlowActionManager
  implements MouseListener,MouseMotionListener,KeyListener{

/** \pl */
  protected ChannelFlowViewPanel view;

/** }EXʒu */
  protected Point mousePoint;

/**
 * ANVǗIuWFNg\z
 * @param view \pl
 */
  public ChannelFlowActionManager(ChannelFlowViewPanel view){
    this.view=view;
    view.addMouseListener(this);
    view.addMouseMotionListener(this);
    view.addKeyListener(this);
    mousePoint=new Point();
  }

//--------------------------------------------------------------------//
/**
 * \plԂ
 * @return \pl
 */
  public ChannelFlowViewPanel getViewPanel(){
    return view;
  }

//--------------------------------------------------------------------//
/**
 * }EX{^̏s
 * @param e }EXANVƂCxg
 */
  public void mousePressed(MouseEvent e){
    mousePoint.setLocation(e.getX(),e.getY());
    view.requestFocus();
  }

//--------------------------------------------------------------------//
/**
 * }EX{^𗣂̏s
 * @param e }EXANVƂCxg
 */
  public void mouseReleased(MouseEvent e){
  }

//--------------------------------------------------------------------//
/**
 * }EXNbN̏s
 * @param e }EXANVƂCxg
 */
  public void mouseClicked(MouseEvent e){
  }

//--------------------------------------------------------------------//
/**
 * }EXR|[lgɓ̏s
 * @param e }EXANVƂCxg
 */
  public void mouseEntered(MouseEvent e){
  }

//--------------------------------------------------------------------//
/**
 * }EXR|[lgȍs
 * @param e }EXANVƂCxg
 */
  public void mouseExited(MouseEvent e){
  }

//--------------------------------------------------------------------//
/**
 * }EXړ̏s
 * @param e }EXANVƂCxg
 */
  public void mouseMoved(MouseEvent e){
  }

//--------------------------------------------------------------------//
/**
 * }EXhbȌs
 * @param e }EXANVƂCxg
 */
  public void mouseDragged(MouseEvent e){
    int x=e.getX();
    int y=e.getY();
    switch(e.getModifiersEx()){
      case MouseEvent.BUTTON1_DOWN_MASK:	// {^
      	view.rotate(x-mousePoint.x,y-mousePoint.y);
      	break;
      case MouseEvent.BUTTON2_DOWN_MASK:	// zC[{^
      	view.zoom(x-mousePoint.x,y-mousePoint.y);
      	break;
      case MouseEvent.BUTTON3_DOWN_MASK:	// E{^
      	view.translate(x-mousePoint.x,y-mousePoint.y);
      	break;
    }
    mousePoint.setLocation(x,y);
    view.update();
  }

//--------------------------------------------------------------------//
/**
 * L[̏s
 * @param e L[ANVƂCxg
 */
  public void keyPressed(KeyEvent e){
    switch(e.getKeyCode()){
      case KeyEvent.VK_Z:
      	view.initView();
      	break;
      case KeyEvent.VK_X:
      	view.viewX();
      	break;
      case KeyEvent.VK_Y:
      	view.viewY();
      	break;
    }
  }

//--------------------------------------------------------------------//
/**
 * L[𗣂̏s
 * @param e L[ANVƂCxg
 */
  public void keyReleased(KeyEvent e){
  }

//--------------------------------------------------------------------//
/**
 * L[^Cv̏s
 * @param e L[ANVƂCxg
 */
  public void keyTyped(KeyEvent e){
  }
}
