package iso.io;
import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileWriter;
import java.io.PrintWriter;
import fileio.TextDataIO;
import iso.ChannelFlowModel;

//--------------------------------------------------------------------//
/**
 * `lf[^o̓NX
 */
public class ChannelFlowIO extends TextDataIO{

/** `lf[^f */
  protected ChannelFlowModel model;

/**
 * Q}bvǂݍ݃IuWFNg\z
 * @param model `lf[^f
 */
  public ChannelFlowIO(ChannelFlowModel model){
    this.model=model;
  }

//--------------------------------------------------------------------//
/**
 * f[^ǂݍ
 * @param name f[^
 * @param br ̓[_[
 * @throws Exception 炩̗RŃt@Cǂ߂ȂƂ
 */
  public void readData(String name,BufferedReader br) throws Exception{
    String line=br.readLine();
    String ss[]=split(line);
    int step=Integer.parseInt(ss[0]);
    double ret=Double.parseDouble(ss[1]);
    int nx=Integer.parseInt(ss[2]);
    int ny=Integer.parseInt(ss[3]);
    int nz=Integer.parseInt(ss[4]);
    double lx=Double.parseDouble(ss[5]);
    double lz=Double.parseDouble(ss[6]);
    double u[][][]=new double[nx][ny+1][nz];
    double v[][][]=new double[nx][ny+1][nz];
    double w[][][]=new double[nx][ny+1][nz];
    double p[][][]=new double[nx][ny+1][nz];
    for(int i=0;i<nx;i++){
      for(int j=0;j<=ny;j++){
      	for(int k=0;k<nz;k++){
      	  ss=split(br.readLine());
      	  u[i][j][k]=Double.parseDouble(ss[0]);
      	  v[i][j][k]=Double.parseDouble(ss[1]);
      	  w[i][j][k]=Double.parseDouble(ss[2]);
      	  p[i][j][k]=Double.parseDouble(ss[3]);
      	}
      }
    }
    model.set(nx,ny,nz,lx,lz,u,v,w,p);
  }

//--------------------------------------------------------------------//
/**
 * f[^
 * @param pw o̓C^[
 * @throws Exception 炩̗RŃt@CȂƂ
 */
  public void writeData(PrintWriter pw) throws Exception{
  }
}
