package laf;
import java.awt.Color;
import javax.swing.plaf.ColorUIResource;
import javax.swing.plaf.metal.DefaultMetalTheme;

//--------------------------------------------------------------------//
/**
 * σ^e[}
 */
public class VariableMetalTheme extends DefaultMetalTheme{

/** ݒł\F̐ */
  public static final int COLORS=8;

/** \F̖ */
  public static final String
    NAME[]={"primary1","primary2","primary3",
      	    "secondary1","secondary2","secondary3",
      	    "black","white"};

/** e[}̖ */
  private String name;

/** \F */
  private ColorUIResource color[]=new ColorUIResource[COLORS];

/**
 * ftHglŃ^e[}\z
 */
  public VariableMetalTheme(){
    init();
  }

/**
 * w肵p[^Ń^e[}\z
 * @param name ^e[}
 * @param color1 ^e[}\F1 (primary1)
 * @param color2 ^e[}\F2 (primary2)
 * @param color3 ^e[}\F3 (primary3)
 * @param color4 ^e[}\F4 (secondary1)
 * @param color5 ^e[}\F5 (secondary2)
 * @param color6 ^e[}\F6 (secondary3)
 * @param color7 ^e[}\F7 (black)
 * @param color8 ^e[}\F8 (white)
 */
  public VariableMetalTheme(String name,Color color1,Color color2,
      	      	      	    Color color3,Color color4,Color color5,
      	      	      	    Color color6,Color color7,Color color8){
    this.name=name;
    color[0]=new ColorUIResource(color1);
    color[1]=new ColorUIResource(color2);
    color[2]=new ColorUIResource(color3);
    color[3]=new ColorUIResource(color4);
    color[4]=new ColorUIResource(color5);
    color[5]=new ColorUIResource(color6);
    color[6]=new ColorUIResource(color7);
    color[7]=new ColorUIResource(color8);
  }

/**
 * w肵p[^Ń^e[}\z
 * @param name ^e[}
 * @param colors ^e[}\Fi[z
 */
  public VariableMetalTheme(String name,Color colors[]){
    init();
    this.name=name;
    int size=Math.min(COLORS,colors.length);
    for(int i=0;i<size;i++) color[i]=new ColorUIResource(colors[i]);
  }

//--------------------------------------------------------------------//
/**
 * ftHglɏ
 */
  public final void init(){
    name=super.getName();
    color[0]=super.getPrimary1();
    color[1]=super.getPrimary2();
    color[2]=super.getPrimary3();
    color[3]=super.getSecondary1();
    color[4]=super.getSecondary2();
    color[5]=super.getSecondary3();
    color[6]=super.getBlack();
    color[7]=super.getWhite();
  }

//--------------------------------------------------------------------//
/**
 * QƂ郁^e[}Ɠp[^ݒ肷
 * @param theme QƂ郁^e[}
 */
  public void setTheme(VariableMetalTheme theme){
    name=theme.getName();
    for(int i=0;i<COLORS;i++){
      color[i]=new ColorUIResource(theme.getColor(i));
    }
  }

//--------------------------------------------------------------------//
/**
 * e[}Ԃ
 * @return ^e[}̖
 */
  public String getName(){
    return name;
  }

//--------------------------------------------------------------------//
/**
 * e[}ݒ肷
 * @param name ^e[}̖
 */
  public void setName(String name){
    this.name=name;
  }

//--------------------------------------------------------------------//
/**
 * \Fݒ肷
 * @param index \Fݒ肷CfbNX
 * @param newColor ݒ肷\F
 */
  public void setColor(int index,Color newColor){
    color[index]=new ColorUIResource(newColor);
  }

//--------------------------------------------------------------------//
/**
 * \FԂ
 * @param index \FoCfbNX
 * @return \F
 */
  public Color getColor(int index){
    return color[index];
  }

//--------------------------------------------------------------------//
/**
 * \F1 (primary1) Ԃ
 * @return \F1 (primary1)
 */
  protected ColorUIResource getPrimary1(){
    return color[0];
  }

//--------------------------------------------------------------------//
/**
 * \F2 (primary2) Ԃ
 * @return \F2 (primary2)
 */
  protected ColorUIResource getPrimary2(){
    return color[1];
  }

//--------------------------------------------------------------------//
/**
 * \F3 (primary3) Ԃ
 * @return \F3 (primary3)
 */
  protected ColorUIResource getPrimary3(){
    return color[2];
  }

//--------------------------------------------------------------------//
/**
 * \F4 (secondary1) Ԃ
 * @return \F4 (secondary1)
 */
  protected ColorUIResource getSecondary1(){
    return color[3];
  }

//--------------------------------------------------------------------//
/**
 * \F5 (secondary2) Ԃ
 * @return \F5 (secondary2)
 */
  protected ColorUIResource getSecondary2(){
    return color[4];
  }

//--------------------------------------------------------------------//
/**
 * \F6 (secondary3) Ԃ
 * @return \F6 (secondary3)
 */
  protected ColorUIResource getSecondary3(){
    return color[5];
  }

//--------------------------------------------------------------------//
/**
 * \F7 (black) Ԃ
 * @return \F7 (black)
 */
  protected ColorUIResource getBlack(){
    return color[6];
  }

//--------------------------------------------------------------------//
/**
 * \F8 (white) Ԃ
 * @return \F8 (white)
 */
  protected ColorUIResource getWhite(){
    return color[7];
  }

//--------------------------------------------------------------------//
/**
 * f[^Ԃ
 * @return ̃IuWFNg̕\
 */
  public String toString(){
    StringBuffer sb=new StringBuffer();
    for(int i=0;i<COLORS;i++){
      sb.append(NAME[i]);
      sb.append('\t');
      int rgb=0x00FFFFFF&color[i].getRGB();
      sb.append(Integer.toString(rgb,16).toUpperCase());
      sb.append('\n');
    }
    return sb.toString();
  }
}
