package shading;
import java.awt.Color;
import java.awt.Point;
import figure.Point3D;
import figure.Triangle3D;
import figure.TriangleCollection;
import figure.Vector3D;

//--------------------------------------------------------------------//
/**
 * VF[fBO̒ۃX[p[NX
 */
public abstract class Shading{

/** wIf */
  protected static final LightModel
    LIGHT_MODEL=new PhongModel(0.7,0.7,20,0.4);

/** ʒ_ */
  protected Point centerPoint;

/** ʕ */
  protected int width;

/** ʍ */
  protected int height;

/**  */
  protected Point3D lightPoint;

/**
 * VF[fBOIuWFNg\z
 * @param centerPoint ʒ_
 * @param width ʕ
 * @param height ʍ
 * @param lightPoint 
 */
  protected Shading(Point centerPoint,int width,int height,
      	      	    Point3D lightPoint){
    this.centerPoint=centerPoint;
    this.width=width;
    this.height=height;
    this.lightPoint=lightPoint;
  }

//--------------------------------------------------------------------//
/**
 * Op`̃VF[fBO`vZ
 * @param tri Op`
 * @param color Op`̐F
 * @param pixel sNZf[^i[z
 * @param zbuf <i>z</i> W̃obt@i[z
 */
  public abstract void shading(Triangle3D tri,Color color,int pixel[],
      	      	      	       double zbuf[]);

//--------------------------------------------------------------------//
/**
 * Op`W̃VF[fBO`vZ
 * @param tc Op`W
 * @param color Ώە̐F
 * @param pixel sNZf[^i[z
 * @param zbuf <i>z</i> W̃obt@i[z
 */
  public void shading(TriangleCollection tc,Color color,int pixel[],
      	      	      double zbuf[]){
    int n=tc.getCount();
    for(int i=0;i<n;i++){
      shading(tc.get(i),color,pixel,zbuf);
    }
  }
}
