package figure;

//--------------------------------------------------------------------//
/**
 * ̃NX
 */
public class Cube3D implements Cloneable{

/** <i>x</i> W */
  public double x;

/** <i>y</i> W */
  public double y;

/** <i>z</i> W */
  public double z;

/** <i>x</i>  */
  public double width;

/** <i>y</i>  */
  public double height;

/** <i>z</i> s */
  public double depth;

/**
 * l (0,0,0,0,0,0) ō\z
 */
  public Cube3D(){
    this(0.0,0.0,0.0,0.0,0.0,0.0);
  }

/**
 * p[^w肵č\z
 * @param x <i>x</i> W
 * @param y <i>y</i> W
 * @param z <i>z</i> W
 * @param width <i>x</i> 
 * @param height <i>y</i> 
 * @param depth <i>z</i> s
 */
  public Cube3D(double x,double y,double z,
      	      	double width,double height,double depth){
    this.x=x;
    this.y=y;
    this.z=z;
    this.width=width;
    this.height=height;
    this.depth=depth;
  }

//--------------------------------------------------------------------//
/**
 * Wݒ肷
 * @param x <i>x</i> W
 * @param y <i>y</i> W
 * @param z <i>z</i> W
 */
  public void setLocation(double x,double y,double z){
    this.x=x;
    this.y=y;
    this.z=z;
  }

//--------------------------------------------------------------------//
/**
 * Wݒ肷
 * @param t W\ <code>Tuple3D</code>
 */
  public void setLocation(Tuple3D t){
    x=t.x;
    y=t.y;
    z=t.z;
  }

//--------------------------------------------------------------------//
/**
 * 傫ݒ肷
 * @param width <i>x</i> 
 * @param height <i>y</i> 
 * @param depth <i>z</i> s
 */
  public void setSize(double width,double height,double depth){
    this.width=width;
    this.height=height;
    this.depth=depth;
  }

//--------------------------------------------------------------------//
/**
 * Eݒ肷
 * @param x <i>x</i> W
 * @param y <i>y</i> W
 * @param z <i>z</i> W
 * @param width <i>x</i> 
 * @param height <i>y</i> 
 * @param depth <i>z</i> s
 */
  public void setBounds(double x,double y,double z,
      	      	      	double width,double height,double depth){
    this.x=x;
    this.y=y;
    this.z=z;
    this.width=width;
    this.height=height;
    this.depth=depth;
  }

//--------------------------------------------------------------------//
/**
 * sړ
 * @param dx <i>x</i> ړ
 * @param dy <i>y</i> ړ
 * @param dz <i>z</i> ړ
 */
  public void translate(double dx,double dy,double dz){
    x+=dx;
    y+=dy;
    z+=dz;
  }

//--------------------------------------------------------------------//
/**
 * sړ
 * @param vector ړʂ\xNg
 */
  public void translate(Vector3D vector){
    x+=vector.x;
    y+=vector.y;
    z+=vector.z;
  }

//--------------------------------------------------------------------//
/**
 * ʒuԂ
 * @return ʒu\ <code>Point3D</code>
 */
  public Point3D getLocation(){
    return new Point3D(x,y,z);
  }

//--------------------------------------------------------------------//
/**
 * SʒuԂ
 * @return Sʒu\ <code>Point3D</code>
 */
  public Point3D getCenterLocation(){
    return new Point3D(x+0.5*width,y+0.5*height,z+0.5*depth);
  }

//--------------------------------------------------------------------//
/**
 * _ǉ<br>
 * ̒̂Ɠ_܂ލŏ̒̂𐶐
 * @param x ǉ_ <i>x</i> W
 * @param y ǉ_ <i>y</i> W
 * @param z ǉ_ <i>z</i> W
 */
  public void add(double x,double y,double z){
    double xmin=Math.min(this.x,x);
    double ymin=Math.min(this.y,y);
    double zmin=Math.min(this.z,z);
    double xmax=Math.max(this.x+width,x);
    double ymax=Math.max(this.y+height,y);
    double zmax=Math.max(this.z+depth,z);
    this.x=xmin;
    this.y=ymin;
    this.z=zmin;
    width=xmax-xmin;
    height=ymax-ymin;
    depth=zmax-zmin;
  }

//--------------------------------------------------------------------//
/**
 * _ǉ<br>
 * ̒̂Ɠ_܂ލŏ̒̂𐶐
 * @param t ǉ <code>Tuple3D</code>
 */
  public void add(Tuple3D t){
    add(t.x,t.y,t.z);
  }

//--------------------------------------------------------------------//
/**
 * ̂ǉ<br>
 * ̒̂ƒǉꂽ̂܂ލŏ̒̂𐶐
 * @param c ǉ钼
 */
  public void add(Cube3D c){
    double xmin=Math.min(x,c.x);
    double ymin=Math.min(y,c.y);
    double zmin=Math.min(z,c.z);
    double xmax=Math.max(x+width,c.x+c.width);
    double ymax=Math.max(y+height,c.y+c.height);
    double zmax=Math.max(z+depth,c.z+c.depth);
    x=xmin;
    y=ymin;
    z=zmin;
    width=xmax-xmin;
    height=ymax-ymin;
    depth=zmax-zmin;
  }

//--------------------------------------------------------------------//
/**
 * _̒̂Ɋ܂܂邩ǂʂ
 * @param x _ <i>x</i> W
 * @param y _ <i>y</i> W
 * @param z _ <i>z</i> W
 * @return w肵_̒̂Ɋ܂܂ꍇ true
 */
  public boolean contains(double x,double y,double z){
    if((width<0) || (height<0) || (depth<0)) return false;
    if((x<this.x) || (y<this.y) || (z<this.z)) return false;
    return ((x<=this.x+width) && (y<=this.y+height)
      	 && (z<=this.z+depth));
  }

//--------------------------------------------------------------------//
/**
 * _̒̂Ɋ܂܂邩ǂʂ
 * @param t _\ <code>Tuple3D</code>
 * @return w肵_̒̂Ɋ܂܂ꍇ true
 */
  public boolean contains(Tuple3D t){
    return contains(t.x,t.y,t.z);
  }

//--------------------------------------------------------------------//
/**
 * ̂̒̂Ɋ܂܂邩ǂʂ
 * @param c 
 * @return w肵̂̒̂Ɋ܂܂ꍇ true
 */
  public boolean contains(Cube3D c){
    if((width<0) || (height<0) || (depth<0)
    || (c.width<0) || (c.height<0) || (c.depth<0)) return false;
    if((c.x<x) || (c.y<y) || (c.z<z)) return false;
    return ((c.x+c.width<=x+width)
      	 && (c.y+c.height<=y+height)
      	 && (c.z+c.depth<=z+depth));
  }

//--------------------------------------------------------------------//
/**
 * IuWFNg̃Rs[Ԃ
 * @return ̃CX^X̕
 */
  public Object clone(){
    try{
      return super.clone();
    }
    catch(CloneNotSupportedException ex){
      throw new InternalError();
    }
  }

//--------------------------------------------------------------------//
/**
 * IuWFNg̃nbVR[hlԂ
 * @return IuWFNg̃nbVR[hl
 */
  public int hashCode(){
    long lx=Double.doubleToLongBits(x);
    long ly=Double.doubleToLongBits(y);
    long lz=Double.doubleToLongBits(z);
    long lw=Double.doubleToLongBits(width);
    long lh=Double.doubleToLongBits(height);
    long ld=Double.doubleToLongBits(depth);
    int bit=(int)(lx^(lx>>>32));
    bit=31*bit+(int)(ly^(ly>>>32));
    bit=31*bit+(int)(lz^(lz>>>32));
    bit=31*bit+(int)(lw^(lw>>>32));
    bit=31*bit+(int)(lh^(lh>>>32));
    bit=31*bit+(int)(ld^(ld>>>32));
    return bit;
  }

//--------------------------------------------------------------------//
/**
 * IuWFNg̓
 * @param obj rΏۂ̃IuWFNg
 * @return rΏۂ̃IuWFNg <code>Cube3D</code>
 *         ̃CX^Xœlꍇ true
 */
  public boolean equals(Object obj){
    if(obj instanceof Cube3D){
      Cube3D c=(Cube3D)obj;
      return ((x==c.x)
      	   && (y==c.y)
      	   && (z==c.z)
      	   && (width==c.width)
      	   && (height==c.height)
      	   && (depth==c.depth));
    }
    else{
      return false;
    }
  }

//--------------------------------------------------------------------//
/**
 * f[^Ԃ
 * @return ̃IuWFNg̕\
 */
  public String toString(){
    return "Cube3D\t"+x+"\t"+y+"\t"+z+"\t"+width+"\t"+height+"\t"+depth;
  }
}
