package figure;

//--------------------------------------------------------------------//
/**
 * 3Op`NX
 */
public class Triangle3D{

/** _1 */
  public Point3D v1;

/** _2 */
  public Point3D v2;

/** _3 */
  public Point3D v3;

/** dS */
  protected Point3D gc;

/** @xNg */
  public Vector3D nv;

/**
 * 3Op`\z
 * @param v1 _1
 * @param v2 _2
 * @param v3 _3
 */
  public Triangle3D(Point3D v1,Point3D v2,Point3D v3){
    this.v1=v1;
    this.v2=v2;
    this.v3=v3;
    gc=new Point3D((v1.x+v2.x+v3.x)/3.0,(v1.y+v2.y+v3.y)/3.0,
      	      	   (v1.z+v2.z+v3.z)/3.0);
    nv=Vector3D.exteriorProduct(new Vector3D(v1,v2),
      	      	      	      	new Vector3D(v1,v3));
    nv.normalize();
  }

//--------------------------------------------------------------------//
/**
 * dSԂ
 * @return dS
 */
  public Point3D center(){
    gc.set((v1.x+v2.x+v3.x)/3.0,(v1.y+v2.y+v3.y)/3.0,
      	   (v1.z+v2.z+v3.z)/3.0);
    return gc;
  }
}
