package fileio;
import java.io.BufferedInputStream;
import java.io.BufferedOutputStream;
import java.io.DataInputStream;
import java.io.DataOutputStream;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.InputStream;
import java.io.OutputStream;

//--------------------------------------------------------------------//
/**
 * oCif[^o͂̒ۃX[p[NX
 */
public abstract class BinaryDataIO extends DataIO{

  protected BinaryDataIO(){
    super();
  }

//--------------------------------------------------------------------//
/**
 * f[^ǂݍ
 * @param name f[^
 * @param dis ̓Xg[
 * @throws Exception 炩̗RŃt@Cǂ߂ȂƂ
 */
  public abstract void readData(String name,DataInputStream dis)
    throws Exception;

/**
 * f[^
 * @param dos o̓Xg[
 * @throws Exception 炩̗RŃt@CȂƂ
 */
  public abstract void writeData(DataOutputStream dos) throws Exception;

//--------------------------------------------------------------------//
/**
 * f[^ǂݍ
 * @param name f[^
 * @param is ̓Xg[
 * @throws Exception 炩̗RŃt@Cǂ߂ȂƂ
 */
  public void read(String name,InputStream is) throws Exception{
    readData(name,new DataInputStream(new BufferedInputStream(is)));
  }

//--------------------------------------------------------------------//
/**
 * t@Cf[^ǂݍ
 * @param file t@C
 * @throws Exception 炩̗RŃt@Cǂ߂ȂƂ
 */
  public void read(File file) throws Exception{
    FileInputStream fis=new FileInputStream(file);
    read(file.getName(),fis);
    if(fis!=null) fis.close();
  }

//--------------------------------------------------------------------//
/**
 * f[^Ƀf[^
 * @param os o̓Xg[
 * @throws Exception 炩̗RŃt@CȂƂ
 */
  public void write(OutputStream os) throws Exception{
    writeData(new DataOutputStream(new BufferedOutputStream(os)));
  }

//--------------------------------------------------------------------//
/**
 * t@CɃf[^
 * @param file t@C
 * @throws Exception 炩̗RŃt@CȂƂ
 */
  public void write(File file) throws Exception{
    FileOutputStream fos=new FileOutputStream(file);
    write(fos);
    fos.close();
  }
}
