package fileio;
import java.awt.event.ActionEvent;
import java.io.File;
import javax.swing.Icon;
import javax.swing.JFileChooser;
import javax.swing.filechooser.FileFilter;
import laf.CommandMap;

//--------------------------------------------------------------------//
/**
 * t@CۑANV
 */
public abstract class FileSaveAction extends FileAccessAction{

/**
 * ANVIuWFNg\z
 */
  protected FileSaveAction(){
    super();
    putValue(NAME,actionName());
  }

/**
 * ACRw肵ăANVIuWFNg\z
 * @param icon ACR
 */
  protected FileSaveAction(Icon icon){
    super(icon);
    putValue(SHORT_DESCRIPTION,actionName());
  }

//--------------------------------------------------------------------//
/**
 * t@CɃf[^ۑ
 * @param file ۑt@C
 * @throws Exception 炩̗RŃt@CȂƂ
 */
  protected abstract void save(File file) throws Exception;

//--------------------------------------------------------------------//
/**
 * t@CɃf[^ۑ
 * @param e ANVƂCxg
 */
  public void actionPerformed(ActionEvent e){
    JFileChooser fileChooser=getFileChooser();
    int ans=fileChooser.showSaveDialog(getDialogOwner());
    if(ans!=fileChooser.APPROVE_OPTION) return;

    currentDirectory=fileChooser.getCurrentDirectory();
    FileFilter filter=fileChooser.getFileFilter();
    File file=modifiedFile(fileChooser.getSelectedFile(),filter);
    try{
      save(file);
    }
    catch(Exception ex){
      showErrorMessage("file save error.",ex);
    }
  }

//--------------------------------------------------------------------//
/**
 * ANV̂Ԃ
 * @return ANV
 */
  public static String actionName(){
    return CommandMap.get(CommandMap.SAVE);
  }
}
