package gui;
import java.awt.Color;
import java.awt.Component;
import java.awt.Dimension;
import java.awt.FontMetrics;
import java.awt.Graphics;
import javax.swing.Icon;

//--------------------------------------------------------------------//
/**
 * F\ACR
 */
public class ColorIcon implements Icon{

/** ftHgTCY */
  public static final Dimension DEFAULT_SIZE=new Dimension(15,10);

/** ACR̐F */
  protected Color color;

/** ACR̕ */
  protected int width;

/** ACR̍ */
  protected int height;

/**
 * F\ACR̍\z
 * @param color ACR̐F
 */
  public ColorIcon(Color color){
    this(color,null);
  }

/**
 * F\ACR\z
 * @param color ACR̐F
 * @param c `lR|[lg
 */
  public ColorIcon(Color color,Component c){
    this.color=color;
    this.setSize(c);
  }

//--------------------------------------------------------------------//
/**
 * ACR`悷
 * @param c R|[lg
 * @param g `悷OtBbNXReLXg
 * @param x `ʒu <i>x</i> W
 * @param y `ʒu <i>y</i> W
 */
  public void paintIcon(Component c,Graphics g,int x,int y){
    setSize(c);
    g.setColor(color);
    g.fillRect(x,y,width,height);
    g.setColor(c.getForeground());
    g.drawRect(x,y,width,height);
  }

//--------------------------------------------------------------------//
/**
 * ACR̕Ԃ
 * @return ACR̕
 */
  public int getIconWidth(){
    return width;
  }

//--------------------------------------------------------------------//
/**
 * ACR̍Ԃ
 * @return ACR̍
 */
  public int getIconHeight(){
    return height;
  }

//--------------------------------------------------------------------//
/**
 * Fݒ肷
 * @param color ݒ肷F
 */
  public void setColor(Color color){
    this.color=color;
  }

//--------------------------------------------------------------------//
/**
 * ACȒ傫ݒ肷
 * @param c `lR|[lg
 */
  protected void setSize(Component c){
    if(c==null){
      width=DEFAULT_SIZE.width;
      height=DEFAULT_SIZE.height;
    }
    else{
      FontMetrics fm=c.getFontMetrics(c.getFont());
      width=(int)(1.2*fm.getHeight());
      height=(int)(0.8*fm.getHeight());
    }
  }
}
