package iso.component;
import java.awt.event.ActionEvent;
import javax.swing.AbstractAction;
import javax.swing.Icon;
import javax.swing.JOptionPane;
import iso.Attribute;
import laf.WordMap;

//--------------------------------------------------------------------//
/**
 * lʕҏWANV
 */
public class EditIsoSurfaceAction extends AbstractAction{

/** \t[ */
  private ChannelFlowViewFrame frame;

/**
 * ANV\z
 * @param frame \t[
 */
  public EditIsoSurfaceAction(ChannelFlowViewFrame frame){
    putValue(NAME,actionName());
    this.frame=frame;
  }

/**
 * ACRw肵ăANV\z
 * @param frame \t[
 * @param icon ACR
 */
  public EditIsoSurfaceAction(ChannelFlowViewFrame frame,Icon icon){
    putValue(SMALL_ICON,icon);
    putValue(SHORT_DESCRIPTION,actionName());
    this.frame=frame;
  }

//--------------------------------------------------------------------//
/**
 * lʂҏW
 * @param e ANVƂCxg
 */
  public void actionPerformed(ActionEvent e){
    JOptionPane.showMessageDialog
      (frame,new IsoSurfaceListPanel(frame),
       WordMap.get(WordMap.ISOSURFACE),JOptionPane.PLAIN_MESSAGE);
  }

//--------------------------------------------------------------------//
/**
 * ANV̂Ԃ
 * @return ANV
 */
  public static String actionName(){
    return WordMap.get(WordMap.EDIT);
  }
}
