package iso.component;
import java.awt.Component;
import javax.swing.DefaultListCellRenderer;
import javax.swing.JList;
import gui.EditableList;
import iso.Attribute;
import iso.IsoSurface;

//--------------------------------------------------------------------//
/**
 * lʃXg
 */
public class IsoSurfaceList extends EditableList{

/**
 * lʃXg\z
 */
  public IsoSurfaceList(){
    super();
    setCellRenderer(new IsoSurfaceListCellRenderer());
  }

//--------------------------------------------------------------------//
/**
 * lʂ̐Ԃ
 * @return lʂ̐
 */
  public int getSurfaceCount(){
    return getDefaultListModel().getSize();
  }

//--------------------------------------------------------------------//
/**
 * lʂԂ
 * @param index lʂ̃CfbNX
 * @return w肳ꂽʒu̓l
 */
  public IsoSurface getIsoSurface(int index){
    return (IsoSurface)getDefaultListModel().get(index);
  }

//--------------------------------------------------------------------//
/**
 * ݑIĂ铙lʂԂ
 * @return ݑIĂ铙l
 */
  public IsoSurface getSelectedIsoSurface(){
    Object value=getSelectedValue();
    if(value instanceof IsoSurface){
      return (IsoSurface)value;
    }
    else{
      return null;
    }
  }

//--------------------------------------------------------------------//
/**
 * lʂu
 * @param index lʂuCfbNX
 * @param s u铙l
 */
  public void setIsoSurface(int index,IsoSurface s){
    if(index>=0){
      getDefaultListModel().set(index,s);
    }
  }

//--------------------------------------------------------------------//
/**
 * ݑIĂ铙lʂu
 * @param s u铙l
 */
  public void setIsoSurface(IsoSurface s){
    setIsoSurface(getSelectedIndex(),s);
  }

//--------------------------------------------------------------------//
/**
 * lʃXg̃Z`NX
 */
  protected class IsoSurfaceListCellRenderer
    extends DefaultListCellRenderer{

    protected IsoSurfaceListCellRenderer(){
      super();
    }

//--------------------------------------------------------------------//
/**
 * lʃXg̃Z`ɎgpR|[lg
 * @param list `悷邽߂Ƀ_O߂ JList
 * @param value Z̒l
 * @param index Z̃CfbNX
 * @param isSelected Z̑I
 * @param cellHasFocus Z̃tH[JX
 * @return Z̕`ɎgpR|[lg
 */
    public Component getListCellRendererComponent
      (JList list,Object value,int index,boolean isSelected,
       boolean cellHasFocus){
      if(value instanceof IsoSurface){
      	if(isSelected){
      	  setBackground(list.getSelectionBackground());
      	  setForeground(list.getSelectionForeground());
      	}
      	else{
      	  setBackground(list.getBackground());
      	  setForeground(list.getForeground());
      	}
      	Attribute attr=((IsoSurface)value).attr;
      	setText(attr.toString());
      	setIcon(new IsoSurfaceIcon(attr,list));
      	return this;
      }
      else{
      	return super.getListCellRendererComponent
      	      	 (list,value,index,isSelected,cellHasFocus);
      }
    }
  }
}
