package laf;
import java.io.InputStream;
import java.io.IOException;
import java.net.URL;
import javax.xml.parsers.ParserConfigurationException;
import org.xml.sax.SAXException;
import resourcemanager.CommandManager;
import resourcemanager.XMLDataMap;

//--------------------------------------------------------------------//
/**
 * R}hǗNX
 */
public class CommandMap extends XMLDataMap{

/** t@C\ */
  public static final String FILE="file";

/** VK쐬mF\ */
  public static final String NEW_CONFIRM="newconfirm";

/** VK쐬\ */
  public static final String NEW="new";

/** x\ */
  public static final String CAUTION="caution";

/** t@Cǂݍ݂\ */
  public static final String LOAD="load";

/** t@Cۑ\ */
  public static final String SAVE="save";

/** t@C_E[h\ */
  public static final String DOWNLOAD="download";

/** lbg[Nڑ\ */
  public static final String CONNECT="connect";

/** \ */
  public static final String PRINT="print";

/** 鑀\ */
  public static final String CLOSE="close";

/** B\ */
  public static final String HIDE="hide";

/** sImF\ */
  public static final String EXIT_CONFIRM="exitconfirm";

/** sI\ */
  public static final String EXIT="exit";

/** ҏW\ */
  public static final String EDIT="edit";

/** Rs[\ */
  public static final String COPY="copy";

/** wv\ */
  public static final String HELP="help";

/** o[W\ */
  public static final String VERSION="version";

/** sI\ */
  public static final String ROW_SELECT="rowselect";

/** I\ */
  public static final String COLUMN_SELECT="columnselect";

/** tHgTCY\ */
  public static final String FONT_SIZE="fontsize";

/** ݒ\ */
  public static final String SET="set";

/** \ */
  public static final String CANCEL="cancel";

/** \ */
  public static final String FINISH="finish";

/** \ */
  public static final String DELETE="delete";

/** f[^i[}bv */
  private static CommandMap current=new CommandMap();

/**
 * R}hǗIuWFNg\z
 */
  public CommandMap(){
    super();
  }

//--------------------------------------------------------------------//
/**
 * R}hf[^ǂݍ
 * @throws ParserConfigurationException
 *         vꂽ\𖞂 <code>DocumentBuilder</code>
 *         𐶐łȂƂ
 * @throws SAXException \̓G[Ƃ
 * @throws IOException o̓G[Ƃ
 */
  public static void read()
    throws ParserConfigurationException,SAXException,IOException{
    read(CommandManager.get());
  }

//--------------------------------------------------------------------//
/**
 * R}hf[^ǂݍ
 * @param language 
 * @throws ParserConfigurationException
 *         vꂽ\𖞂 <code>DocumentBuilder</code>
 *         𐶐łȂƂ
 * @throws SAXException \̓G[Ƃ
 * @throws IOException o̓G[Ƃ
 */
  public static void read(String language)
    throws ParserConfigurationException,SAXException,IOException{
    if(language.equals(DrawParameter.JAPANESE)){
      read(CommandManager.get(CommandManager.J_FILE_NAME));
    }
    else{
      read(CommandManager.get());
    }
  }

//--------------------------------------------------------------------//
/**
 * R}hf[^ǂݍ
 * @param url f[^ URL
 * @throws ParserConfigurationException
 *         vꂽ\𖞂 <code>DocumentBuilder</code>
 *         𐶐łȂƂ
 * @throws SAXException \̓G[Ƃ
 * @throws IOException o̓G[Ƃ
 */
  public static void read(URL url)
    throws ParserConfigurationException,SAXException,IOException{
    current.readFromURL(url);
  }

//--------------------------------------------------------------------//
/**
 * R}hf[^ǂݍ
 * @param is ̓Xg[
 * @throws ParserConfigurationException
 *         vꂽ\𖞂 <code>DocumentBuilder</code>
 *         𐶐łȂƂ
 * @throws SAXException \̓G[Ƃ
 * @throws IOException o̓G[Ƃ
 */
  public static void read(InputStream is)
    throws ParserConfigurationException,SAXException,IOException{
    current.readFromStream(is);
  }

//--------------------------------------------------------------------//
/**
 * R}hf[^Ԃ
 * @param key R}h̃L[
 * @return R}h
 */
  public static String get(String key){
    return current.getName(key);
  }
}
